<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title>uWeaver UI - API documentation : Source: datetime.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link href="styles/bootstrap.css" rel="stylesheet">
    <link href="styles/docs.css" rel="stylesheet">
    <link href="styles/bootstrap-custom.css" rel="stylesheet">
    <link href="http://netdna.bootstrapcdn.com/font-awesome/3.2.1/css/font-awesome.css" rel="stylesheet">
    <script src="http://netdna.bootstrapcdn.com/twitter-bootstrap/2.3.2/js/bootstrap.min.js"></script>
  </head>
  <body>
    <header class="header navbar navbar-inverse">
      <div class="navbar-inner">
        <div class="container-fluid">
          <a class="brand" href="#"><strong>uWeaver UI</strong> API documentation</a>
        </div>
      </div>
    </header>

    <div class="container-fluid">
      <div class="row-fluid">
          <div class="span4">
              <h2><a href="index.html">Index</a></h2><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Modules</li><li><a href="module-boolean.html">boolean</a></li>
<li><a href="module-datetime.html">datetime</a></li>
<li><a href="module-dom.html">dom</a></li>
<li><a href="module-environment.html">environment</a></li>
<li><a href="module-formatter.html">formatter</a></li>
<li><a href="module-i18n.html">i18n</a></li>
<li><a href="module-lang.html">lang</a></li>
<li><a href="module-net.html">net</a></li>
<li><a href="module-number.html">number</a></li>
<li><a href="module-uweaver.html">uweaver</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Classes</li><li><a href="Activities.html"><i class="icon-shield" style="color: #0186d1"></i> Activities</a></li><li><a href="Activity.html"><i class="icon-shield" style="color: #0186d1"></i> Activity</a></li><li><a href="Applet.html"><i class="icon-shield" style="color: #0186d1"></i> Applet</a></li><li><a href="BaseObject.html"><i class="icon-shield" style="color: #0186d1"></i> BaseObject</a></li><li><a href="Button.html"><i class="icon-shield" style="color: #0186d1"></i> Button</a></li><li><a href="CartesianChart.html"><i class="icon-shield" style="color: #0186d1"></i> CartesianChart</a></li><li><a href="Checkbox.html"><i class="icon-shield" style="color: #0186d1"></i> Checkbox</a></li><li><a href="Collection.html"><i class="icon-shield" style="color: #0186d1"></i> Collection</a></li><li><a href="Combobox.html"><i class="icon-shield" style="color: #0186d1"></i> Combobox</a></li><li><a href="Container.html"><i class="icon-shield" style="color: #0186d1"></i> Container</a></li><li><a href="Datebox.html"><i class="icon-shield" style="color: #0186d1"></i> Datebox</a></li><li><a href="Datepicker.html"><i class="icon-shield" style="color: #0186d1"></i> Datepicker</a></li><li><a href="Filebox.html"><i class="icon-shield" style="color: #0186d1"></i> Filebox</a></li><li><a href="Filedropper.html"><i class="icon-shield" style="color: #0186d1"></i> Filedropper</a></li><li><a href="Form.html"><i class="icon-shield" style="color: #0186d1"></i> Form</a></li><li><a href="Gadget.html"><i class="icon-shield" style="color: #0186d1"></i> Gadget</a></li><li><a href="Grid.html"><i class="icon-shield" style="color: #0186d1"></i> Grid</a></li><li><a href="Icon.html"><i class="icon-shield" style="color: #0186d1"></i> Icon</a></li><li><a href="Inputbox.html"><i class="icon-shield" style="color: #0186d1"></i> Inputbox</a></li><li><a href="Item.html"><i class="icon-shield" style="color: #0186d1"></i> Item</a></li><li><a href="Json.html"><i class="icon-shield" style="color: #0186d1"></i> Json</a></li><li><a href="Logger.html"><i class="icon-shield" style="color: #0186d1"></i> Logger</a></li><li><a href="MDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> MDIApplet</a></li><li><a href="Memory.html"><i class="icon-shield" style="color: #0186d1"></i> Memory</a></li><li><a href="Menu.html"><i class="icon-shield" style="color: #0186d1"></i> Menu</a></li><li><a href="Model.html"><i class="icon-shield" style="color: #0186d1"></i> Model</a></li><li><a href="Numberbox.html"><i class="icon-shield" style="color: #0186d1"></i> Numberbox</a></li><li><a href="Pagination.html"><i class="icon-shield" style="color: #0186d1"></i> Pagination</a></li><li><a href="Panel.html"><i class="icon-shield" style="color: #0186d1"></i> Panel</a></li><li><a href="PolarChart.html"><i class="icon-shield" style="color: #0186d1"></i> PolarChart</a></li><li><a href="Popup.html"><i class="icon-shield" style="color: #0186d1"></i> Popup</a></li><li><a href="Portal.html"><i class="icon-shield" style="color: #0186d1"></i> Portal</a></li><li><a href="Proxy.html"><i class="icon-shield" style="color: #0186d1"></i> Proxy</a></li><li><a href="Radiobutton.html"><i class="icon-shield" style="color: #0186d1"></i> Radiobutton</a></li><li><a href="Reader.html"><i class="icon-shield" style="color: #0186d1"></i> Reader</a></li><li><a href="Selectbox.html"><i class="icon-shield" style="color: #0186d1"></i> Selectbox</a></li><li><a href="Site.html"><i class="icon-shield" style="color: #0186d1"></i> Site</a></li><li><a href="Sites.html"><i class="icon-shield" style="color: #0186d1"></i> Sites</a></li><li><a href="Store.html"><i class="icon-shield" style="color: #0186d1"></i> Store</a></li><li><a href="TabPanel.html"><i class="icon-shield" style="color: #0186d1"></i> TabPanel</a></li><li><a href="TDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> TDIApplet</a></li><li><a href="Testbench.html"><i class="icon-shield" style="color: #0186d1"></i> Testbench</a></li><li><a href="Testlet.html"><i class="icon-shield" style="color: #0186d1"></i> Testlet</a></li><li><a href="Textbox.html"><i class="icon-shield" style="color: #0186d1"></i> Textbox</a></li><li><a href="Toolbox.html"><i class="icon-shield" style="color: #0186d1"></i> Toolbox</a></li><li><a href="Trigger.html"><i class="icon-shield" style="color: #0186d1"></i> Trigger</a></li><li><a href="Triggers.html"><i class="icon-shield" style="color: #0186d1"></i> Triggers</a></li><li><a href="User.html"><i class="icon-shield" style="color: #0186d1"></i> User</a></li><li><a href="Users.html"><i class="icon-shield" style="color: #0186d1"></i> Users</a></li><li><a href="Violation.html"><i class="icon-shield" style="color: #0186d1"></i> Violation</a></li><li><a href="Widget.html"><i class="icon-shield" style="color: #0186d1"></i> Widget</a></li><li><a href="WindowManager.html"><i class="icon-shield" style="color: #0186d1"></i> WindowManager</a></li><li><a href="Workbench.html"><i class="icon-shield" style="color: #0186d1"></i> Workbench</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Global</li><li><a href="global.html#_anchors"><i class="icon-globe" style="color: black;"></i> _anchors</a></li><li><a href="global.html#_form"><i class="icon-globe" style="color: black;"></i> _form</a></li><li><a href="global.html#_interact"><i class="icon-globe" style="color: black;"></i> _interact</a></li><li><a href="global.html#_marker"><i class="icon-globe" style="color: black;"></i> _marker</a></li><li><a href="global.html#_tabPanel"><i class="icon-globe" style="color: black;"></i> _tabPanel</a></li><li><a href="global.html#browse"><i class="icon-globe" style="color: black;"></i> browse</a></li><li><a href="global.html#draggable"><i class="icon-globe" style="color: black;"></i> draggable</a></li><li><a href="global.html#events"><i class="icon-globe" style="color: black;"></i> events</a></li><li><a href="global.html#initialize"><i class="icon-globe" style="color: black;"></i> initialize</a></li><li><a href="global.html#layout"><i class="icon-globe" style="color: black;"></i> layout</a></li><li><a href="global.html#logger"><i class="icon-globe" style="color: black;"></i> logger</a></li><li><a href="global.html#login"><i class="icon-globe" style="color: black;"></i> login</a></li><li><a href="global.html#onDragstart"><i class="icon-globe" style="color: black;"></i> onDragstart</a></li><li><a href="global.html#onTabsActivate"><i class="icon-globe" style="color: black;"></i> onTabsActivate</a></li><li><a href="global.html#onTaskSelect"><i class="icon-globe" style="color: black;"></i> onTaskSelect</a></li><li><a href="global.html#perform"><i class="icon-globe" style="color: black;"></i> perform</a></li><li><a href="global.html#prepare"><i class="icon-globe" style="color: black;"></i> prepare</a></li><li><a href="global.html#requirejs"><i class="icon-globe" style="color: black;"></i> requirejs</a></li><li><a href="global.html#start"><i class="icon-globe" style="color: black;"></i> start</a></li><li><a href="global.html#toUrl"><i class="icon-globe" style="color: black;"></i> toUrl</a></li><li><a href="global.html#validate"><i class="icon-globe" style="color: black;"></i> validate</a></li></ul></div>
          </div>

          <div class="span8">
              <h1 class="page-header">Source: datetime.js</h1>
              


    
    <section>
        <article>
            <pre class="prettyprint source"><code>/**
 * This document is a part of the source code and related artifacts
 * for uWeaver, an open source application development framework for
 * Enterprise Application Software.
 *
 *      http://www.uweaver.org
 *
 * Copyright 2016 Jason Lin
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


/**
 * The datetime module provides a collection of utility methods for manipulating dates and allows you to choosing
 * user-defined patterns for date-time formatting.
 *
 * Date and time formats are specified by date and time pattern strings. The pattern strings are designed to
 * conform to java.text.SimpleDateFormat.
 *
 * ##### Usage
 *     // Mar 04 2010 05:06:07.008 GMT+0800
 *     var time = new Date(new Date(Date.UTC(2010, 2, 4, 5, 6, 7, 8)).getTime() - 8 * 3600000);
 *
 *     // Mar 04 2010 05:06:07.008 at local time
 *     var localTime = new Date(2010, 2, 4, 5, 6, 7, 8);
 *
 *     // Mar 04 2010 at local time
 *     var localDate = new Date(2010, 2, 4);
 *
 *     // ISO 8601 data &amp; time representation format.
 *     expect(datetime.format(time)).to.equal("2010-03-04T05:06:07.008+0800");
 *     expect(datetime.format(localTime, "yyyy/MM/dd HH:mm:ss.SSS")).to.equal("2010/03/04 05:06:07.008");
 *     expect(datetime.format(localTime, "yyyy/MM/dd HH:mm:ss")).to.equal("2010/03/04 05:06:07");
 *     expect(datetime.format(localDate, "yyyy/MM/dd")).to.equal("2010/03/04");
 *     expect(datetime.format(localDate, "yyyy/M/d")).to.equal("2010/3/4");
 *
 *     // ISO 8601 data &amp; time representation format.
 *     expect(datetime.parse("2010-03-04T05:06:07.008+0800")).to.equalTime(time);
 *     expect(datetime.parse("2010/03/04 05:06:07.008", "yyyy/MM/dd HH:mm:ss.SSS")).to.equalTime(localTime);
 *     expect(datetime.parse("2010/03/04", "yyyy/MM/dd")).to.equalTime(localDate);
 *     expect(datetime.parse("2010/3/4", "yyyy/M/d")).to.equalTime(localDate);
 *
 *     expect(datetime.convert("2010-03-04T05:06:07.008+0800")).to.equalTime(time);
 *     expect(datetime.convert(time.getTime())).to.equalTime(time);
 *     expect(datetime.convert("2010/03/04 05:06:07.008", "yyyy/MM/dd HH:mm:ss.SSS")).to.equalTime(localTime);
 *     expect(datetime.convert("2010/03/04", "yyyy/MM/dd")).to.equalTime(localDate);
 *
 * @module datetime
 * @author  Jason Lin
 * @since   1.0
 */
define(['underscore', 'uweaver/string', 'uweaver/exception/InvalidFormatException',
    'uweaver/exception/UnsupportedTypeException'], function(_, string, InvalidFormatException, UnsupportedTypeException) {

    // ISO 8601 data &amp; time representation format.
    var DATETIMEPATTERN = "yyyy-MM-ddTHH:mm:ss.SSSZ";

    var MASKS = {
        y: {
            reg: new RegExp('[y]{4}', 'i'),
            expr: '[0-9]{4}'
        },
        M: {
            reg: new RegExp('[M]{1,2}'),
            expr: '[0-9]{1,2}'
        },
        d: {
            reg: new RegExp('[d]{1,2}'),
            expr: '[0-9]{1,2}'
        },
        H: {
            reg: new RegExp('[H]{1,2}'),
            expr: '[0-9]{1,2}'
        },
        m: {
            reg: new RegExp('[m]{1,2}'),
            expr: '[0-9]{1,2}'
        },
        s: {
            reg: new RegExp('[s]{1,2}'),
            expr: '[0-9]{1,2}'
        },
        S: {
            reg: new RegExp('\\.[S]{3}'),
            expr: '\\.[0-9]{1,3}'
        },
        Z: {
            reg: new RegExp('Z'),
            expr: '.[0-9]{4}'
        }
    };

    /**
     * The method parses a string representation of a date using the specified pattern and returns the date.
     *
     * @memberof module:datetime
     * @param {String} text - the text to convert.
     * @param {String} [pattern="yyyy-MM-ddTHH:mm:ss.SSSZ"] - specify a date pattern to parse the text.
     * @returns {Date|void}
     */
    function parse(text, pattern) {
        if(text===null||text===undefined) {
            return null;
        } else if(!_.isString(text)) {
            throw new UnsupportedTypeException({
                type: typeof text,
                supportedTypes: ['String']
            });
        } else if(text.length===0) {
            return null;
        }

        pattern || (pattern = DATETIMEPATTERN);

        text = text.replace(/Z$/, "+0000");

        if(!testPattern(text, pattern)) {
            throw new InvalidFormatException({
                entity: text,
                format: pattern
            });
        }

        var time;
        var year = 1970, month = 1, date = 1, hours = 0, minutes = 0, seconds = 0, milliseconds = 0;
        var timezone;

        try {
            pattern.indexOf('y')!==-1 &amp;&amp; (year = parseInt(parseValue(text, pattern, 'y')));
            pattern.indexOf('M')!==-1 &amp;&amp; (month = parseInt(parseValue(text, pattern, 'M')));
            pattern.indexOf('d')!==-1 &amp;&amp; (date = parseInt(parseValue(text, pattern, 'd')));
            pattern.indexOf('H')!==-1 &amp;&amp; (hours = parseInt(parseValue(text, pattern, 'H')));
            pattern.indexOf('m')!==-1 &amp;&amp; (minutes = parseInt(parseValue(text, pattern, 'm')));
            pattern.indexOf('s')!==-1 &amp;&amp; (seconds = parseInt(parseValue(text, pattern, 's')));
            pattern.indexOf('S')!==-1 &amp;&amp; (milliseconds = parseInt(parseValue(text, pattern, 'S').substr(1)));
            pattern.indexOf('Z')!==-1 &amp;&amp; (timezone = parseValue(text, pattern, 'Z'));
        } catch (err) {
            throw new InvalidFormatException({
                entity: text,
                format: pattern,
                cause: err
            });
        }

        if(timezone) {
            var offset = rfc822Offset(timezone);
            var localOffset = new Date().getTimezoneOffset();

            time = new Date(year, month-1, date, hours, minutes + offset - localOffset, seconds, milliseconds);
        } else {
            time = new Date(year, month-1, date, hours, minutes, seconds, milliseconds);
        }

        if((timezone==='+0000'||timezone==='+0800'||!timezone) &amp;&amp; this.format(time, pattern, timezone)!==text) {
            throw new InvalidFormatException({
                entity: text,
                format: pattern
            });
        }

        return time;
    }

    function parseValue(text, pattern, name) {
        pattern = '^' + pattern + '$';
        var letters = MASKS[name].reg.exec(pattern);

        if(letters===null) return null;

        var tokens = pattern.split(letters);
        var exprBefore = tokens[0];
        var exprAfter = tokens[1];

        _.each(MASKS, function(mask, key) {
            if (key===name) return;
            exprBefore = exprBefore.replace(mask.reg, mask.expr);
            exprAfter = exprAfter.replace(mask.reg, mask.expr);
        });

        return text.replace(new RegExp(exprBefore), '').replace(new RegExp(exprAfter), '');
    }

    /**
     * The method formats a date to a string representation using the specified pattern.
     *
     * @memberof module:datetime
     * @param {Date} value - the date to format.
     * @param {String} [pattern="yyyy-MM-ddTHH:mm:ss.SSSZ"] - specify a date pattern to format the value.
     * @returns {String|null}
     */
    function format(value, pattern, timezone) {
        if(value===null||value===undefined) {
            return null;
        } else if(!_.isDate(value)) {
            throw new UnsupportedTypeException({
                type: typeof value,
                supportedTypes: ['Date']
            });
        }

        pattern || (pattern = DATETIMEPATTERN);

        var template = pattern;

        var values;

        if(timezone==='+0000') {
            values = {
                y: value.getUTCFullYear(),
                M: value.getUTCMonth()+1,
                d: value.getUTCDate(),
                H: value.getUTCHours(),
                m: value.getUTCMinutes(),
                s: value.getUTCSeconds(),
                S: value.getUTCMilliseconds(),
                Z: ''
            };
        } else {
            values = {
                y: value.getFullYear(),
                M: value.getMonth()+1,
                d: value.getDate(),
                H: value.getHours(),
                m: value.getMinutes(),
                s: value.getSeconds(),
                S: value.getMilliseconds(),
                Z: ''
            };
        }

        var letters;
        if(values.M&lt;10) {
            letters = MASKS.M.reg.exec(pattern);
            (letters) &amp;&amp; letters[0].length>=2 &amp;&amp; (values.M = '0' + values.M);
        }
        if(values.d&lt;10) {
            letters = MASKS.d.reg.exec(pattern);
            (letters) &amp;&amp; letters[0].length>=2 &amp;&amp; (values.d = '0' + values.d);
        }
        if(values.H&lt;10) {
            letters = MASKS.H.reg.exec(pattern);
            (letters) &amp;&amp; letters[0].length>=2 &amp;&amp; (values.H = '0' + values.H);
        }
        if(values.m&lt;10) {
            letters = MASKS.m.reg.exec(pattern);
            (letters) &amp;&amp; letters[0].length>=2 &amp;&amp; (values.m = '0' + values.m);
        }
        if(values.s&lt;10) {
            letters = MASKS.s.reg.exec(pattern);
            (letters) &amp;&amp; letters[0].length>=2 &amp;&amp; (values.s = '0' + values.s);
        }
        if(values.S&lt;100) {
            letters = MASKS.S.reg.exec(pattern);
            if(letters) {
                for(var i=values.S.toString().length+1; i&lt;=letters[0].length-1; i++) {
                    values.
                        S = '0' + values.S;
                }
            }
        }
        if(values.S) {
            values.S = '.' + values.S;
        }

        values.Z = (timezone) ? timezone : rfc822Timezone(value.getTimezoneOffset());

        _.each(MASKS, function(mask, key) {
            template = template.replace(mask.reg, '${' + key + '}');
        });

        return string.substitute(template, values);
    }

    function rfc822Timezone(offset) {
        var sign = (offset>0) ? '-' : '+';
        offset = Math.abs(offset);
        var hoursOffset = Math.floor(offset/60);
        var minutesOffset = offset - hoursOffset * 60;
        if(hoursOffset&lt;10) hoursOffset = '0' + hoursOffset;
        if(minutesOffset&lt;10) minutesOffset = '0' + minutesOffset;

        return sign + hoursOffset + minutesOffset;
    }

    function rfc822Offset(timezone) {
        var sign = timezone.substr(0, 1);
        var hoursOffset = parseInt(timezone.substr(1, 2));
        var minutesOffset = parseInt(timezone.substr(3, 2));
        var offset = (hoursOffset * 60 + minutesOffset);

        return (sign==='+') ? offset * -1 : offset;
    }

    /**
     * The method converts a value to a date using the specified pattern.
     *
     * @memberof module:datetime
     * @param {String|Number|Date} value - the value to convert.
     * @param {String} [pattern="yyyy-MM-ddTHH:mm:ss.SSSZ"] - specify a date pattern to parse the text.
     * @returns {Date}
     */
    function convert(value, pattern) {
        if(value===undefined||value===null) return value;
        if(_.isDate(value)) {
            return value;
        } else if(_.isNumber(value)) {
            return new Date(value);
        } else if(_.isString(value)) {
            if(value.length===0) return null;
            return this.parse(value, pattern);
        } else {
            throw new UnsupportedTypeException({
                type: typeof value,
                supportedTypes: ["String", "Number", "Date"]
            });
        }
    }

    /**
     * The method tests if a string representation is a date using a specified pattern.
     *
     * @memberof module:datetime
     * @param {String} text - the text to check.
     * @param {String} [pattern="yyyy-MM-ddTHH:mm:ss.SSSZ"] - specify a date pattern to check the text.
     * @returns {Boolean}
     */
    function test(text, pattern) {
        try {
            this.parse(text, pattern);
        } catch(err) {
            return false;
        }

        return true;
    }

    function testPattern(text, pattern) {
        pattern || (pattern = DATETIMEPATTERN);

        var expr = '^' + pattern + '$';

        _.each(MASKS, function(mask) {
            expr = expr.replace(mask.reg, mask.expr);
        });


        return new RegExp(expr).test(text);
    }

    return {
        parse: parse,
        format: format,
        convert: convert,
        test: test
    };
});</code></pre>
        </article>
    </section>




          </div>
      </div>

        <br clear="both">

      <footer>
        Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.3.2</a> on Fri Aug 26 2016 10:58:19 GMT+0800 (CST)
        <br>
      </footer>
      <script> prettyPrint(); </script>
    </div>
  </body>
</html>
